<i18n>
{
  "fr": {
    "title-1": "Les BGES",
    "title-2": "Supprimer BGES",
    "info-1": "L'ensemble des BGES de votre laboratoire sont listés dans le tableau ci-dessous. Depuis ce tableau, vous pouvez ajouter, charger et supprimer un BGES.",
    "info-2": "Aucun BGES",
    "info-3": "Êtes vous sûr de vouloir supprimer le BGES",
    "field-1": "Année",
    "tooltip-1": "Charger le BGES",
    "tooltip-2": "Supprimer le BGES",
    "tooltip-3": "Charger le lien publique du BGES"
  },
  "en": {
    "title-1": "The GHG inventories",
    "title-2": "Delete GHGI",
    "info-1": "All the GHG inventories (GHGIs) of your laboratory are listed in the table below. From this table, you can add, upload and delete a GHGI." ,
    "info-2": "No GHG inventory",
    "info-3": "Are you sure that you want to delete the GHGI",
    "field-1": "Year",
    "tooltip-1": "Load the GHGI",
    "tooltip-2": "Delete the GHGI",
    "tooltip-3": "Load the GHGI public link"
  }
}
</i18n>

<template>
  <div>
    <su-service :icon="'thermometer'">
      <template #title>
        {{ $t('title-1') }}
      </template>
      {{ $t('info-1') }}
    </su-service>
    <br />
    <contrails-switch
      :withContrails.sync="withContrails"
    />
    <b-table
      :data="allGHGI"
      :striped="true"
      :narrowed="true"
      :hoverable="true"
    >
      <b-table-column :label="$t('field-1')" sticky v-slot="props">
        {{ props.row.year }}
      </b-table-column>
      <b-table-column :label="$t('buildings')" numeric v-slot="props">
        <nobr>
          {{ Math.round(getBuildingsIntensity(props)) | splitNumberTons }} &plusmn;
          {{ Math.round(getBuildingsUncertainty(props)) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column :label="$t('vehicles')" numeric v-slot="props">
        <nobr>
          {{ Math.round(props.row.emissions.vehicles.intensity.intensity) | splitNumberTons }} &plusmn;
          {{ Math.round(props.row.emissions.vehicles.intensity.uncertainty) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column :label="$t('travels')" numeric v-slot="props">
        <nobr v-if="withContrails">
          {{ Math.round(props.row.emissions.travels.intensity.intensitywc) | splitNumberTons }} &plusmn;
          {{ Math.round(props.row.emissions.travels.intensity.uncertaintywc) | splitNumberTons }}
        </nobr>
        <nobr v-else>
          {{ Math.round(props.row.emissions.travels.intensity.intensity) | splitNumberTons }} &plusmn;
          {{ Math.round(props.row.emissions.travels.intensity.uncertainty) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column :label="$t('commutes')" numeric v-slot="props">
        <nobr>
          {{ Math.round(props.row.emissions.commutes.intensity.intensity) | splitNumberTons }} &plusmn;
          {{ Math.round(props.row.emissions.commutes.intensity.uncertainty) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column :label="$t('computer.devices')" numeric v-slot="props">
        <nobr>
          {{ Math.round(props.row.emissions.devices.intensity.intensity) | splitNumberTons }} &plusmn;
          {{ Math.round(props.row.emissions.devices.intensity.uncertainty) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column :label="$t('purchases')" numeric v-slot="props">
        <nobr>
          {{ Math.round(props.row.emissions.purchases.intensity.intensity) | splitNumberTons }} &plusmn;
          {{ Math.round(props.row.emissions.purchases.intensity.uncertainty) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column :label="$t('total')" numeric v-slot="props">
        <nobr>
          {{ getTotalIntensity(props) | splitNumberTons }} &plusmn; {{ getTotalUncertainty(props) | splitNumberTons }}
        </nobr>
      </b-table-column>
      <b-table-column v-slot="props">
        <div class="panel-block">
          <b-tooltip
            :label="$t('tooltip-1')"
            type="is-black"
          >
            <b-button
              size="is-small"
              type="is-primary"
              icon-left="cloud-download"
              @click="loadGHGI(props.row.id)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('tooltip-3')"
            type="is-black"
            position="is-left"
          >
            <b-button
              size="is-small"
              icon-left="external-link"
              @click="copyGHGILink(props.row.id)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('tooltip-2')"
            type="is-black"
            position="is-left"
          >
            <b-button
              size="is-small"
              :disabled="deleteDisabled(props.row)"
              icon-right="trash"
              @click="deleteGHGI(props.row)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>{{ $t('info-2') }}</p>
        </div>
      </section>
    </b-table>
    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            icon-left="plus"
            @click="createGHGI()"
          >
            {{ $t('add') }}
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import { CarbonIntensities } from '@/models/carbon/CarbonIntensity.js'

export default {
  name: 'AllGHGI',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'contrails-switch': () => import('@/components/carbon/utils/ContrailsSwitch.vue')
  },
  data () {
    return {
      withContrails: true
    }
  },
  computed: {
    allGHGI: function () {
      return this.$store.getters['admin/allGHGI']
    }
  },
  methods: {
    deleteDisabled (ghgi) {
      return ghgi.buildingsSubmitted || ghgi.commutesSubmitted || ghgi.travelsSubmitted || ghgi.vehiclesSubmitted || ghgi.devicesSubmitted || ghgi.purchasesSubmitted
    },
    deleteGHGI (ghgi) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('title-2') + ' ' + ghgi.year,
        message: self.$t('info-3') + ' <b> ' + ghgi.year + '</b> ?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          const loadingComponent = self.$buefy.loading.open({
            container: null
          })
          self.$store.dispatch('admin/deleteGHGIDescription', ghgi.id)
            .then(data => {
              loadingComponent.close()
            })
            .catch((erreur) => {
              loadingComponent.close()
            })
        }
      })
    },
    createGHGI () {
      this.$store.dispatch('ghgi/resetGHGI')
      this.$router.push('/ges-1point5/0')
    },
    copyGHGILink (ghgiID) {
      let ghgi = this.allGHGI.find(obj => obj.id === ghgiID)
      let route = this.$router.resolve({ path: '/ges-1point5-results/' + ghgi.uuid })
      window.open(route.href, '_blank')
    },
    loadGHGI (ghgiID) {
      this.$router.push('/ges-1point5/' + ghgiID)
    },
    getBuildingsIntensity: function (props) {
      let intensity = new CarbonIntensities()
      intensity.add(props.row.emissions.buildings.heatings.intensity)
      intensity.add(props.row.emissions.buildings.electricity)
      intensity.add(props.row.emissions.buildings.refrigerants)
      return intensity.sum().intensity
    },
    getBuildingsUncertainty: function (props) {
      let intensity = new CarbonIntensities()
      intensity.add(props.row.emissions.buildings.heatings.intensity)
      intensity.add(props.row.emissions.buildings.electricity)
      intensity.add(props.row.emissions.buildings.refrigerants)
      return intensity.sum().uncertainty
    },
    getTotalIntensity: function (props) {
      let intensity = new CarbonIntensities()
      intensity.add(props.row.emissions.buildings.heatings.intensity)
      intensity.add(props.row.emissions.buildings.electricity)
      intensity.add(props.row.emissions.buildings.refrigerants)
      intensity.add(props.row.emissions.vehicles.intensity)
      intensity.add(props.row.emissions.travels.intensity)
      intensity.add(props.row.emissions.commutes.intensity)
      intensity.add(props.row.emissions.devices.intensity)
      intensity.add(props.row.emissions.purchases.intensity)
      if (this.withContrails) {
        return intensity.intensitywc
      } else {
        return intensity.intensity
      }
    },
    getTotalUncertainty: function (props) {
      let intensity = new CarbonIntensities()
      intensity.add(props.row.emissions.buildings.heatings.intensity)
      intensity.add(props.row.emissions.buildings.electricity)
      intensity.add(props.row.emissions.buildings.refrigerants)
      intensity.add(props.row.emissions.vehicles.intensity)
      intensity.add(props.row.emissions.travels.intensity)
      intensity.add(props.row.emissions.commutes.intensity)
      intensity.add(props.row.emissions.devices.intensity)
      intensity.add(props.row.emissions.purchases.intensity)
      if (this.withContrails) {
        return intensity.uncertaintywc
      } else {
        return intensity.uncertainty
      }
    }
  }
}
</script>

<style>
.is-sticky {
  background: #fafafa !important;
}
.table td {
  vertical-align: middle !important;
}
.table th {
  vertical-align: middle !important;
}
</style>
